Index: /palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4833)
+++ /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4834)
@@ -358,46 +359,46 @@
     INTEGER(iwp) ::  i_bound     !< boundary grid point in x-direction for scalars, v, and w
     INTEGER(iwp) ::  i_bound_u   !< boundary grid point in x-direction for u
+    INTEGER(iwp) ::  i_end       !< end index for array allocation along x-direction at norther/southern boundary
     INTEGER(iwp) ::  i_start     !< start index for array allocation along x-direction at norther/southern boundary (scalars, v, w)
     INTEGER(iwp) ::  i_start_u   !< start index for array allocation along x-direction at norther/southern boundary (u)
-    INTEGER(iwp) ::  i_end       !< end index for array allocation along x-direction at norther/southern boundary
     INTEGER(iwp) ::  j_bound     !< boundary grid point in y-direction for scalars, u, and w
     INTEGER(iwp) ::  j_bound_v   !< boundary grid point in y-direction for v
+    INTEGER(iwp) ::  j_end       !< end index for array allocation along y-direction at eastern/western boundary
     INTEGER(iwp) ::  j_start     !< start index for array allocation along y-direction at eastern/western boundary (scalars, u, w)
     INTEGER(iwp) ::  j_start_v   !< start index for array allocation along y-direction at eastern/western boundary (v)
-    INTEGER(iwp) ::  j_end       !< end index for array allocation along y-direction at eastern/western boundary
     INTEGER(iwp) ::  lod         !< level-of-detail of lateral input data
 
     REAL(wp) ::  fac_dt              !< interpolation factor
-    REAL(wp) ::  zi_ribulk = 0.0_wp  !< boundary-layer depth according to bulk Richardson criterion, i.e. the height where Ri_bulk exceeds the critical
-                                     !< bulk Richardson number of 0.2
-
-    TYPE(nest_offl_type) ::  nest_offl  !< data structure for data input at lateral and top boundaries (provided by Inifor) 
-    
+    REAL(wp) ::  zi_ribulk = 0.0_wp  !< boundary-layer depth according to bulk Richardson criterion, i.e. the height where Ri_bulk
+                                     !< exceeds the critical bulk Richardson number of 0.2
+
+    TYPE(nest_offl_type) ::  nest_offl  !< data structure for data input at lateral and top boundaries (provided by Inifor)
+
     SAVE
     PRIVATE
 !
 !-- Public subroutines
-    PUBLIC nesting_offl_bc,                                                    &
-           nesting_offl_calc_zi,                                               &
-           nesting_offl_check_parameters,                                      &
-           nesting_offl_geostrophic_wind,                                      &
-           nesting_offl_header,                                                &
-           nesting_offl_init,                                                  &
-           nesting_offl_input,                                                 &
-           nesting_offl_interpolation_factor,                                  &
-           nesting_offl_mass_conservation,                                     &
-           nesting_offl_parin 
+    PUBLIC nesting_offl_bc,                                                                        &
+           nesting_offl_calc_zi,                                                                   &
+           nesting_offl_check_parameters,                                                          &
+           nesting_offl_geostrophic_wind,                                                          &
+           nesting_offl_header,                                                                    &
+           nesting_offl_init,                                                                      &
+           nesting_offl_input,                                                                     &
+           nesting_offl_interpolation_factor,                                                      &
+           nesting_offl_mass_conservation,                                                         &
+           nesting_offl_parin
 !
 !-- Public variables
-    PUBLIC zi_ribulk   
+    PUBLIC zi_ribulk
 
     INTERFACE nesting_offl_bc
        MODULE PROCEDURE nesting_offl_bc
     END INTERFACE nesting_offl_bc
-    
+
     INTERFACE nesting_offl_calc_zi
        MODULE PROCEDURE nesting_offl_calc_zi
     END INTERFACE nesting_offl_calc_zi
-    
+
     INTERFACE nesting_offl_check_parameters
        MODULE PROCEDURE nesting_offl_check_parameters
@@ -407,9 +408,9 @@
        MODULE PROCEDURE nesting_offl_geostrophic_wind
     END INTERFACE nesting_offl_geostrophic_wind
-    
+
     INTERFACE nesting_offl_header
        MODULE PROCEDURE nesting_offl_header
     END INTERFACE nesting_offl_header
-    
+
     INTERFACE nesting_offl_init
        MODULE PROCEDURE nesting_offl_init
@@ -423,9 +424,9 @@
        MODULE PROCEDURE nesting_offl_interpolation_factor
     END INTERFACE nesting_offl_interpolation_factor
-           
+
     INTERFACE nesting_offl_mass_conservation
        MODULE PROCEDURE nesting_offl_mass_conservation
     END INTERFACE nesting_offl_mass_conservation
-    
+
     INTERFACE nesting_offl_parin
        MODULE PROCEDURE nesting_offl_parin
@@ -434,98 +435,93 @@
  CONTAINS
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Reads data at lateral and top boundaries derived from larger-scale model.
-!------------------------------------------------------------------------------!
-    SUBROUTINE nesting_offl_input
-
-       INTEGER(iwp) ::  n   !< running index for chemistry variables
-
-!
-!--    Initialize INIFOR forcing in first call. 
-       IF ( .NOT. nest_offl%init )  THEN
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE nesting_offl_input
+
+    INTEGER(iwp) ::  n   !< running index for chemistry variables
+
+!
+!-- Initialize INIFOR forcing in first call.
+    IF ( .NOT. nest_offl%init )  THEN
 #if defined ( __netcdf )
 !
-!--       Open file in read-only mode
-          CALL open_read_file( TRIM( input_file_dynamic ) //                   &
-                               TRIM( coupling_char ), pids_id )
-!
-!--       At first, inquire all variable names.
-          CALL inquire_num_variables( pids_id, num_var_pids )
-!
-!--       Allocate memory to store variable names.
-          ALLOCATE( nest_offl%var_names(1:num_var_pids) )
-          CALL inquire_variable_names( pids_id, nest_offl%var_names )
-!
-!--       Read time dimension, allocate memory and finally read time array
-          CALL get_dimension_length( pids_id, nest_offl%nt, 'time' )
-
-          IF ( check_existence( nest_offl%var_names, 'time' ) )  THEN
-             ALLOCATE( nest_offl%time(0:nest_offl%nt-1) )
-             CALL get_variable( pids_id, 'time', nest_offl%time )
-          ENDIF
-!
-!--       Read vertical dimension of scalar und w grid
-          CALL get_dimension_length( pids_id, nest_offl%nzu, 'z' )
-          CALL get_dimension_length( pids_id, nest_offl%nzw, 'zw' )
-
-          IF ( check_existence( nest_offl%var_names, 'z' ) )  THEN
-             ALLOCATE( nest_offl%zu_atmos(1:nest_offl%nzu) )
-             CALL get_variable( pids_id, 'z', nest_offl%zu_atmos )
-          ENDIF
-          IF ( check_existence( nest_offl%var_names, 'zw' ) )  THEN
-             ALLOCATE( nest_offl%zw_atmos(1:nest_offl%nzw) )
-             CALL get_variable( pids_id, 'zw', nest_offl%zw_atmos )
-          ENDIF
-!
-!--       Read surface pressure
-          IF ( check_existence( nest_offl%var_names,                           &
-                                'surface_forcing_surface_pressure' ) )  THEN
-             ALLOCATE( nest_offl%surface_pressure(0:nest_offl%nt-1) )
-             CALL get_variable( pids_id,                                       &
-                                'surface_forcing_surface_pressure',            &
-                                nest_offl%surface_pressure )
-          ENDIF
-!
-!--       Close input file
-          CALL close_input_file( pids_id )
+!--    Open file in read-only mode
+       CALL open_read_file( TRIM( input_file_dynamic ) // TRIM( coupling_char ), pids_id )
+!
+!--    At first, inquire all variable names.
+       CALL inquire_num_variables( pids_id, num_var_pids )
+!
+!--    Allocate memory to store variable names.
+       ALLOCATE( nest_offl%var_names(1:num_var_pids) )
+       CALL inquire_variable_names( pids_id, nest_offl%var_names )
+!
+!--    Read time dimension, allocate memory and finally read time array
+       CALL get_dimension_length( pids_id, nest_offl%nt, 'time' )
+
+       IF ( check_existence( nest_offl%var_names, 'time' ) )  THEN
+          ALLOCATE( nest_offl%time(0:nest_offl%nt-1) )
+          CALL get_variable( pids_id, 'time', nest_offl%time )
+       ENDIF
+!
+!--    Read vertical dimension of scalar und w grid
+       CALL get_dimension_length( pids_id, nest_offl%nzu, 'z' )
+       CALL get_dimension_length( pids_id, nest_offl%nzw, 'zw' )
+
+       IF ( check_existence( nest_offl%var_names, 'z' ) )  THEN
+          ALLOCATE( nest_offl%zu_atmos(1:nest_offl%nzu) )
+          CALL get_variable( pids_id, 'z', nest_offl%zu_atmos )
+       ENDIF
+       IF ( check_existence( nest_offl%var_names, 'zw' ) )  THEN
+          ALLOCATE( nest_offl%zw_atmos(1:nest_offl%nzw) )
+          CALL get_variable( pids_id, 'zw', nest_offl%zw_atmos )
+       ENDIF
+!
+!--    Read surface pressure
+       IF ( check_existence( nest_offl%var_names, 'surface_forcing_surface_pressure' ) )  THEN
+          ALLOCATE( nest_offl%surface_pressure(0:nest_offl%nt-1) )
+          CALL get_variable( pids_id, 'surface_forcing_surface_pressure',                          &
+                             nest_offl%surface_pressure )
+       ENDIF
+!
+!--    Close input file
+       CALL close_input_file( pids_id )
 #endif
-       ENDIF
-!
-!--    Check if dynamic driver data input is required.
-       IF ( nest_offl%time(nest_offl%tind_p) <=                                &
-            MAX( time_since_reference_point, 0.0_wp)  .OR.                     &
-            .NOT.  nest_offl%init )  THEN
-          CONTINUE
-!
-!--    Return otherwise
-       ELSE
-          RETURN
-       ENDIF
-!
-!--    Start of CPU measurement
-       CALL cpu_log( log_point_s(86), 'NetCDF input forcing', 'start' )
-!
-!--    Obtain time index for current point in time. Note, the time coordinate
-!--    in the input file is always relative to the initial time in UTC, i.e.
-!--    the time coordinate always starts at 0.0 even if the initial UTC is e.g.
-!--    7200.0. Further, since time_since_reference_point is negativ here when 
-!--    spinup is applied, use MAX function to obtain correct time index. 
-       nest_offl%tind = MINLOC( ABS( nest_offl%time - MAX( time_since_reference_point, 0.0_wp) ),  &
-                                DIM = 1 ) - 1
-!
-!--    Note, in case of restart runs, the time index for the boundary data may indicate a time
-!--    in the future. This needs to be checked and corrected.
+    ENDIF
+!
+!-- Check if dynamic driver data input is required.
+    IF ( nest_offl%time(nest_offl%tind_p) <= MAX( time_since_reference_point, 0.0_wp)  .OR.        &
+         .NOT.  nest_offl%init )  THEN
+       CONTINUE
+!
+!-- Return otherwise
+    ELSE
+       RETURN
+    ENDIF
+!
+!-- Start of CPU measurement
+    CALL cpu_log( log_point_s(86), 'NetCDF input forcing', 'start' )
+
+!
+!-- Obtain time index for current point in time. Note, the time coordinate in the input file is
+!-- always relative to the initial time in UTC, i.e. the time coordinate always starts at 0.0 even
+!-- if the initial UTC is e.g. 7200.0. Further, since time_since_reference_point is negativ here
+!-- when spinup is applied, use MAX function to obtain correct time index.
+    nest_offl%tind = MINLOC( ABS( nest_offl%time - MAX( time_since_reference_point, 0.0_wp ) ),    &
+                             DIM = 1 ) - 1
+!
+!--    Note, in case of restart runs, the time index for the boundary data may indicate a time in
+!--    the future. This needs to be checked and corrected.
        IF ( TRIM( initializing_actions ) == 'read_restart_data'  .AND.                             &
             nest_offl%time(nest_offl%tind) > time_since_reference_point )  THEN
           nest_offl%tind = nest_offl%tind - 1
        ENDIF
-       nest_offl%tind_p = nest_offl%tind + 1
-!
-!--    Open file in read-only mode
+    nest_offl%tind_p = nest_offl%tind + 1
+!
+!-- Open file in read-only mode
 #if defined ( __netcdf )
-       CALL open_read_file( TRIM( input_file_dynamic ) //                                          &
-                            TRIM( coupling_char ), pids_id )
+    CALL open_read_file( TRIM( input_file_dynamic ) // TRIM( coupling_char ), pids_id )
 !
 !--    Read geostrophic wind components
@@ -537,93 +533,121 @@
 !        ENDDO
 !
-!--    Read data at lateral and top boundaries. Please note, at left and
-!--    right domain boundary, yz-layers are read for u, v, w, pt and q.
-!--    For the v-component, the data starts at nysv, while for the other
-!--    quantities the data starts at nys. This is equivalent at the north
-!--    and south domain boundary for the u-component (nxlu).
-!--    Note, lateral data is also accessed by parallel IO, which is the reason
-!--    why different arguments are passed depending on the boundary control
-!--    flags. Cores that do not belong to the respective boundary only do
-!--    a dummy read with count = 0, just in order to participate the collective
-!--    operation. This is because collective parallel access shows better
-!--    performance than just a conditional access.
-!--    Read data for LOD 2, i.e. time-dependent xz-, yz-, and xy-slices.
-       IF ( lod == 2 )  THEN
-          CALL get_variable( pids_id, 'ls_forcing_left_u',                                         &
-                             nest_offl%u_l,                                                        & ! array to be read
-                             MERGE( nys+1, 1, bc_dirichlet_l),                                     & ! start index y direction
-                             MERGE( nzb+1, 1, bc_dirichlet_l),                                     & ! start index z direction
-                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                          & ! start index time dimension
-                             MERGE( nyn-nys+1, 0, bc_dirichlet_l),                                 & ! number of elements along y
-                             MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                             & ! number of elements alogn z
-                             MERGE( 2, 0, bc_dirichlet_l),                                         & ! number of time steps (2 or 0)
-                             .TRUE. )                                                                ! parallel IO when compiled accordingly
-
-          CALL get_variable( pids_id, 'ls_forcing_left_v',                                         &
-                             nest_offl%v_l,                                                        &
-                             MERGE( nysv, 1, bc_dirichlet_l),                                      &
-                             MERGE( nzb+1, 1, bc_dirichlet_l),                                     &
-                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                          &
-                             MERGE( nyn-nysv+1, 0, bc_dirichlet_l),                                &
-                             MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                             &
-                             MERGE( 2, 0, bc_dirichlet_l),                                         &
-                             .TRUE. )
-
-          CALL get_variable( pids_id, 'ls_forcing_left_w',                                         &
-                             nest_offl%w_l,                                                        &
+!-- Read data at lateral and top boundaries. Please note, at left and right domain boundary,
+!-- yz-layers are read for u, v, w, pt and q.
+!-- For the v-component, the data starts at nysv, while for the other quantities the data starts at
+!-- nys. This is equivalent at the north and south domain boundary for the u-component (nxlu).
+!-- Note, lateral data is also accessed by parallel IO, which is the reason why different arguments
+!-- are passed depending on the boundary control flags. Cores that do not belong to the respective
+!-- boundary only do a dummy read with count = 0, just in order to participate the collective
+!-- operation. This is because collective parallel access shows better performance than just a
+!-- conditional access.
+!-- Read data for LOD 2, i.e. time-dependent xz-, yz-, and xy-slices.
+    IF ( lod == 2 )  THEN
+       CALL get_variable( pids_id, 'ls_forcing_left_u',                                            &
+                          nest_offl%u_l,                                                           & ! array to be read
+                          MERGE( nys+1, 1, bc_dirichlet_l),                                        & ! start index y direction
+                          MERGE( nzb+1, 1, bc_dirichlet_l),                                        & ! start index z direction
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                             & ! start index time dimension
+                          MERGE( nyn-nys+1, 0, bc_dirichlet_l),                                    & ! number of elements along y
+                          MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                                & ! number of elements alogn z
+                          MERGE( 2, 0, bc_dirichlet_l),                                            & ! number of time steps (2 or 0)
+                          .TRUE. )                                                                   ! parallel IO when compiled accordingly
+
+       CALL get_variable( pids_id, 'ls_forcing_left_v',                                            &
+                          nest_offl%v_l,                                                           &
+                          MERGE( nysv, 1, bc_dirichlet_l),                                         &
+                          MERGE( nzb+1, 1, bc_dirichlet_l),                                        &
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                             &
+                          MERGE( nyn-nysv+1, 0, bc_dirichlet_l),                                   &
+                          MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                                &
+                          MERGE( 2, 0, bc_dirichlet_l),                                            &
+                          .TRUE. )
+
+       CALL get_variable( pids_id, 'ls_forcing_left_w',                                            &
+                          nest_offl%w_l,                                                           &
+                          MERGE( nys+1, 1, bc_dirichlet_l),                                        &
+                          MERGE( nzb+1, 1, bc_dirichlet_l),                                        &
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                             &
+                          MERGE( nyn-nys+1, 0, bc_dirichlet_l),                                    &
+                          MERGE( nest_offl%nzw, 0, bc_dirichlet_l),                                &
+                          MERGE( 2, 0, bc_dirichlet_l),                                            &
+                          .TRUE. )
+
+       IF ( .NOT. neutral )  THEN
+          CALL get_variable( pids_id, 'ls_forcing_left_pt',                                        &
+                             nest_offl%pt_l,                                                       &
                              MERGE( nys+1, 1, bc_dirichlet_l),                                     &
                              MERGE( nzb+1, 1, bc_dirichlet_l),                                     &
                              MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                          &
                              MERGE( nyn-nys+1, 0, bc_dirichlet_l),                                 &
-                             MERGE( nest_offl%nzw, 0, bc_dirichlet_l),                             &
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                             &
                              MERGE( 2, 0, bc_dirichlet_l),                                         &
-                             .TRUE. )   
-
-          IF ( .NOT. neutral )  THEN
-             CALL get_variable( pids_id, 'ls_forcing_left_pt',                                     &
-                                nest_offl%pt_l,                                                    &
-                                MERGE( nys+1, 1, bc_dirichlet_l),                                  &
-                                MERGE( nzb+1, 1, bc_dirichlet_l),                                  &
-                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                       &
-                                MERGE( nyn-nys+1, 0, bc_dirichlet_l),                              &
-                                MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                          &
-                                MERGE( 2, 0, bc_dirichlet_l),                                      &
-                                .TRUE. )
-          ENDIF
-
-          IF ( humidity )  THEN
-             CALL get_variable( pids_id, 'ls_forcing_left_qv',                                     &
-                                nest_offl%q_l,                                                     &
-                                MERGE( nys+1, 1, bc_dirichlet_l),                                  &
-                                MERGE( nzb+1, 1, bc_dirichlet_l),                                  &
-                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                       &
-                                MERGE( nyn-nys+1, 0, bc_dirichlet_l),                              &
-                                MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                          &
-                                MERGE( 2, 0, bc_dirichlet_l),                                      &
-                                .TRUE. )
-          ENDIF
-
-          IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
-             DO  n = 1, UBOUND(nest_offl%var_names_chem_l, 1)
-                IF ( check_existence( nest_offl%var_names,                                         &
-                                      nest_offl%var_names_chem_l(n) ) )  THEN
-                   CALL get_variable( pids_id,                                                     &
-                                      TRIM( nest_offl%var_names_chem_l(n) ),                       &
-                                      nest_offl%chem_l(:,:,:,n),                                   &
-                                      MERGE( nys+1, 1, bc_dirichlet_l),                            &
-                                      MERGE( nzb+1, 1, bc_dirichlet_l),                            &
-                                      MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                 &
-                                      MERGE( nyn-nys+1, 0, bc_dirichlet_l),                        &
-                                      MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                    &
-                                      MERGE( 2, 0, bc_dirichlet_l),                                &
-                                      .TRUE. )
-                   nest_offl%chem_from_file_l(n) = .TRUE.
-                ENDIF
-             ENDDO
-          ENDIF
-!
-!--       Read data for eastern boundary    
-          CALL get_variable( pids_id, 'ls_forcing_right_u',                                        &
-                             nest_offl%u_r,                                                        &
+                             .TRUE. )
+       ENDIF
+
+       IF ( humidity )  THEN
+          CALL get_variable( pids_id, 'ls_forcing_left_qv',                                        &
+                             nest_offl%q_l,                                                        &
+                             MERGE( nys+1, 1, bc_dirichlet_l),                                     &
+                             MERGE( nzb+1, 1, bc_dirichlet_l),                                     &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                          &
+                             MERGE( nyn-nys+1, 0, bc_dirichlet_l),                                 &
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                             &
+                             MERGE( 2, 0, bc_dirichlet_l),                                         &
+                             .TRUE. )
+       ENDIF
+
+       IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+          DO  n = 1, UBOUND( nest_offl%var_names_chem_l, 1 )
+             IF ( check_existence( nest_offl%var_names, nest_offl%var_names_chem_l(n) ) )  THEN
+                CALL get_variable( pids_id,                                                        &
+                                   TRIM( nest_offl%var_names_chem_l(n) ),                          &
+                                   nest_offl%chem_l(:,:,:,n),                                      &
+                                   MERGE( nys+1, 1, bc_dirichlet_l),                               &
+                                   MERGE( nzb+1, 1, bc_dirichlet_l),                               &
+                                   MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                    &
+                                   MERGE( nyn-nys+1, 0, bc_dirichlet_l),                           &
+                                   MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                       &
+                                   MERGE( 2, 0, bc_dirichlet_l),                                   &
+                                   .TRUE. )
+                nest_offl%chem_from_file_l(n) = .TRUE.
+             ENDIF
+          ENDDO
+       ENDIF
+!
+!--    Read data for eastern boundary
+       CALL get_variable( pids_id, 'ls_forcing_right_u',                                           &
+                          nest_offl%u_r,                                                           &
+                          MERGE( nys+1, 1, bc_dirichlet_r),                                        &
+                          MERGE( nzb+1, 1, bc_dirichlet_r),                                        &
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),                             &
+                          MERGE( nyn-nys+1, 0, bc_dirichlet_r),                                    &
+                          MERGE( nest_offl%nzu, 0, bc_dirichlet_r),                                &
+                          MERGE( 2, 0, bc_dirichlet_r),                                            &
+                          .TRUE. )
+
+       CALL get_variable( pids_id, 'ls_forcing_right_v',                                           &
+                          nest_offl%v_r,                                                           &
+                          MERGE( nysv, 1, bc_dirichlet_r),                                         &
+                          MERGE( nzb+1, 1, bc_dirichlet_r),                                        &
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),                             &
+                          MERGE( nyn-nysv+1, 0, bc_dirichlet_r),                                   &
+                          MERGE( nest_offl%nzu, 0, bc_dirichlet_r),                                &
+                          MERGE( 2, 0, bc_dirichlet_r),                                            &
+                          .TRUE. )
+
+       CALL get_variable( pids_id, 'ls_forcing_right_w',                                           &
+                          nest_offl%w_r,                                                           &
+                          MERGE( nys+1, 1, bc_dirichlet_r),                                        &
+                          MERGE( nzb+1, 1, bc_dirichlet_r),                                        &
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),                             &
+                          MERGE( nyn-nys+1, 0, bc_dirichlet_r),                                    &
+                          MERGE( nest_offl%nzw, 0, bc_dirichlet_r),                                &
+                          MERGE( 2, 0, bc_dirichlet_r),                                            &
+                          .TRUE. )
+
+       IF ( .NOT. neutral )  THEN
+          CALL get_variable( pids_id, 'ls_forcing_right_pt',                                       &
+                             nest_offl%pt_r,                                                       &
                              MERGE( nys+1, 1, bc_dirichlet_r),                                     &
                              MERGE( nzb+1, 1, bc_dirichlet_r),                                     &
